Fixed sourcing of $PWD/rip_dvd.conf file if present
[rip_dvd/.git] / rip_dvd
diff --git a/rip_dvd b/rip_dvd
index afa9aa853f90e2544151c14a9436477c3ef180c0..ebcd87ff162d2e652ec0c60330d8e050534ea39c 100755 (executable)
--- a/rip_dvd
+++ b/rip_dvd
 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
 #
 
-##############################################################################
-# Local Machine Settings:
-# Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
-# and the local conf file created by each local machine (rip_dvd.conf)
-# Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
-# This will allow you to override all the default values to meet your needs
-# in a way that won't get clobbered when you pull updates from my GIT repo.
-##############################################################################
-config="${0%/*}/rip_dvd.conf"
-[ -e "${config}.dist" ] && . ${config}.dist
-[ -e "${config}" ] && . ${config}
-
 ##############################################################################################
-# Command line processing
+# Global Variables
 ##############################################################################################
 typeset cmd="$0 $*"
 typeset dvdname=""
@@ -52,6 +40,7 @@ typeset SCALE=""
 typeset CROP=""
 typeset profile="xvidvhq"
 typeset extension=""
+typeset mailto=""
 typeset -i force_onepass_mode=0
 typeset -i eject_disk=1
 typeset -i keep_isofile=0
@@ -72,6 +61,40 @@ typeset -i invalid_feature_title=0
 typeset -i feature_title_override=0
 typeset -i mplayer_dumpstream_incompatibility=0
 
+##############################################################################
+# Local Machine Settings:
+# Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
+# and the local conf file created by each local machine (rip_dvd.conf)
+# Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
+# This will allow you to override all the default values to meet your needs
+# in a way that won't get clobbered when you pull updates from my GIT repo.
+##############################################################################
+config="${0%/*}/rip_dvd.conf"
+
+# The config file will be searched for in the following location order:
+found_config=0
+
+# 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
+[ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
+
+# 2) /path/to/rip_dvd/script/rip_dvd.conf
+[ -e "${config}" ] && found_config=1 && . "${config}"
+
+# 3) /etc/rip_dvd.conf
+[ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
+
+# 4) $PWD/rip_dvd.conf
+[ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
+
+# Check to make sure we found the config file
+if [ $found_config -eq 0 ]; then
+  echo "-E- Unable to find the rip_dvd.conf file: $config"
+  exit 1
+fi
+
+##############################################################################################
+# Command line processing
+##############################################################################################
 while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j: opt "$@"
 do
     case $opt in
@@ -108,10 +131,9 @@ function usage() {
     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
-    echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
-    echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
-    echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
-    echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
@@ -217,6 +239,7 @@ fi
 
 typeset -i ripdvd
 if [ -z "$dvdname" ]; then
+
   # make sure the DVD device is accessible
   volname $dev > /dev/null 2>&1
   if [ $? != 0 ]; then
@@ -226,7 +249,9 @@ if [ -z "$dvdname" ]; then
   # now capture the volume name from the device
   dvdname=`volname $dev | awk '{ print $1 }'`
   ripdvd=1
+
 else 
+
   # check to see if dvdname is a full path to a real directory
   # if it is, set dvdname and dvdpath appropriately
   if [ -d "$dvdname" ]; then
@@ -276,10 +301,19 @@ else
       echo "-E- Unsupported file type: $vobfile"
       exit 1
     fi
+
+  # Throw an error if we can't find what the -n option is pointing to
+  else 
+    echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
+    exit 1
   fi
+
+  # Set the ripdvd flag to false since we aren't ripping a DVD disk
   ripdvd=0
-  # Since we aren't ripping a DVD disk, don't eject anything
+
+  # Since we aren't ripping a DVD disk, don't eject anything either
   eject_disk=0
+
 fi
 
 # remove bad characters from the dvdname
@@ -395,7 +429,7 @@ function encode_vob_file {
   if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
     found_profile=1
     final_output_file="$dest/$dvdname.avi"
-    mencoder_general_opts="-quiet $lang_opts $passlogfile_opt"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
@@ -449,10 +483,11 @@ function encode_vob_file {
   fi
 
   # MP4 encoding profiles
+  # These are currently in BETA. They don't work that great. A new recipe is needed, for the audio.
   if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
     found_profile=1
     final_output_file="$dest/$dvdname.mp4"
-    mencoder_general_opts="-quiet $lang_opts $passlogfile_opt"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
@@ -503,13 +538,13 @@ function encode_vob_file {
       #mencoder_audioch_opts[1]="-af channels=6"
       #mencoder_audioch_opts[2]=""
       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
-      mencoder_audioch_opts[0]="-channels 6 -srate 48000"
+      mencoder_audioch_opts[0]="-channels 6 -srate 48000 -af volnorm=1"
     else
       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
       #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
       #mencoder_audioch_opts[0]=""
       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
-      mencoder_audioch_opts[0]="-channels 2 -srate 48000"
+      mencoder_audioch_opts[0]="-channels 2 -srate 48000 -af volnorm=1"
     fi
 
   fi
@@ -531,7 +566,7 @@ function encode_vob_file {
       SCALE=",dsize=320:240:0,scale=-8:-8"
     fi
     final_output_file="$dest/$dvdname.mp4"
-    mencoder_general_opts="-quiet $lang_opts $passlogfile_opt"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
@@ -592,7 +627,7 @@ function encode_vob_file {
     fi
 
     # Concatenate the encode log to our main log file, greping out unwanted lines
-    cat $encodelog | grep -v "Pos:" >> "$logfile"
+    cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
 
   done
 }
@@ -1326,4 +1361,4 @@ if [ $mirror_mode -eq 0 ]; then
 
 fi
 
-##############################################################################################
\ No newline at end of file
+##############################################################################################